
% hydro		Hydrogen atom wavefunctions     (L. Kocbach, UiB)
%
%               changed to deltaR  Aug 23 2007   deltaR=0.005
%               LAST SMALL CHANGE: Oct. 21st, 2003
%               changed the steppings in n_slide and l_slide
%
%		The wavefunctions are evaluated symbolically
%      http://www.fi.uib.no/AMOS/hydro/               		
%               The program for visualization of radial function.
%		Wavefunctions shown in a window. 
%		The user can control function parameters interactively.
%		
%               all functions up to n=11		
%               any other n,l can be generated
%               if the program is only slightly modified
%               or if the routines are called
%
%   This version includes three modes of plotting
%
%   1. R(r)     2. r R(r)    3. r^2 (R(r))^2 - density
%
%   This version also 'prettyprints' the
%   algebraic formulae for the wavefunctions
%   Matlab 5 and 6 version
%   Last modified 12.oct.2001
%
%   Built on a course work by Irina Otdelnova (1997)
%   http://www.fi.uib.no/~irina/fys292.html
%   Algebraic parts and further development: Ladislav Kocbach
%   This projects homepage:
%   http://www.fi.uib.no/AMOS/hydro/
%
% Some notes: I use first two MATLAB windows (Figure #1
% and Figure #2). If there are any open windows when the
% program is using, they will remain untouched.
%
% n and l given unphysical values, range initialized.

          rangelog=2;    deltaR=0.005
          n=1;l=0;range=2^rangelog; % changed
          nold=n;lold=l;

% An array of numbers starting from 0 to range with step of range/100
% These are the points at which the function is evaluated.
% This array is used later on for graphs.

n=1; l=0;
          x=0:deltaR:range;

format compact

% Open graph window #1

          F1=figure;

% Open control window #2 with sliders

          F2=figure;
          set(F2,'menu','none','numbertitle','off','name','Control Window');

 % Resizing the control window

          pos1=get(F1,'position');
          pos=get(F2,'position');
	  pos1(1)=305;pos1(2)=255;
	  pos(1)=pos1(1)-300;
	  pos(2)=pos1(2)-250;
          pos(3)=300;pos(4)=250;  % dimensions of the command window;
          set(F2,'position',pos);
	  set(F1,'position',pos1);

% Main Control Functions: Title, exit, type of displaying.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

          TitleF= uicontrol('style','text', ...
                 'string','Controls for Wavefunction Tool', ...
                 'position', [10 225 275 20]);
          ExitBut=uicontrol('style','pushbutton',...
	         'string','EXIT','position', [10 200 50 20],...
	         'callback','close(F1);close(F2);');
	         
          ufff_values=[ 1 0 0 ];
          ufff1=uicontrol('style','radiobutton',...
 	     'string','Plot R(r) ' ,'value',1,...
 	     'min',0,'max',1,...
 	     'position', [10 178 100 20],...
 	     'callback',[ ...
 	     'nold=-1;ufff_values=[ 0 0 0 ];ufff_values(1)=1;' ...
 	     'set(ufff1,''value'',1);set(ufff2,''value'',0);set(ufff3,''value'',0);' ...
 	     'updater;']);
          ufff2=uicontrol('style','radiobutton',...
 	     'string', ' r*R(r) ','value',0 ,...
 	     'min',0,'max',1,...
 	     'position', [10 155 100 20],...
 	     'callback',[ ...
 	     'nold=-1;ufff_values=[ 0 0 0 ];ufff_values(2)=1;' ...
 	     'set(ufff1,''value'',0);set(ufff2,''value'',1);set(ufff3,''value'',0);' ...
 	     'updater;']);
          ufff3=uicontrol('style','radiobutton',...
 	     'string','  r^2*[ R(r) ]^2 ','value',0,...
 	     'min',0,'max',1,...
 	     'position', [10 132 100 20],...
 	     'callback',[ ...
 	     'nold=-1;ufff_values=[ 0 0 0 ];ufff_values(3)=1;' ...
 	     'set(ufff1,''value'',0);set(ufff2,''value'',0);set(ufff3,''value'',1);' ...
 	     'updater;']);	


% Control of Paramter 'n'
%%%%%%%%%%%%%%%%%%%%%%%%%%

% Text field with value of 'n'

         n_text = uicontrol('style','text', ...
	        'string','n=', 'position',[10 20  80 20]);


% Callback for n_slide (updates value of 'n' in the text-field
% and redraws the graph; it is contained in script file updaten.m

        n_slide = uicontrol('style','slider', ...
	         'min',0,'max',11.2,'Sliderstep',[0.1 0.105],...
	         'position',[100 20  160 20], ...
	         'value',n, ...
	         'callback',['n=get(n_slide,''value'');updaten;']);


% Control of Paramter 'l'
%%%%%%%%%%%%%%%%%%%%%%%%%%

% Text field with value of 'l'

        l_text = uicontrol('style','text', ...
	       'string','l=', 'position',[10 60  80 20]);

% Callback for n_slide (updates value of 'n' in the text-field
% and redraws the graph

% The actual slider control

        l_slide = uicontrol('style','slider', ...
	        'min',0,'max',10.5,'Sliderstep',[0.1 0.101], ...
	        'position',[100 60  160 20], ...
	        'value',l, ...
	        'callback',['l=get(l_slide,''value'');updatel;']);

% Parameter 'range' 
%%%%%%%%%%%%%%%%%%%%

% Text field with value of 'range'

        r_text = uicontrol('style','text', ...
	        'string','range=  4.0', 'position',[10 100 80 20]);

% Callback for r_slide (updates value of 'range' in the text-field
% and redraws the graph

%updater='eval(update_graph);set(r_text,''string'',[''range='' num2str(range)]);';

% The actual slider control

        r_slide = uicontrol('style','slider', ...
	         'min',1.5,'max',8.5, ...
	         'position',[100 100  160 20], ...
	         'value',rangelog, ...
	         'callback',['rangelog=get(r_slide,''value'');updater;']);

% Parameter 'Evaluating...'
%%%%%%%%%%%%%%%%%%%%%%%%%%%

% The following code does not work with some Matlab versions. If you have such 
% problem try to use a different version of it.
         figure(F1);
          mess1=uicontrol('style','edit', ...
              'string','Evaluating the symbolics ..........', ...
              'BackgroundColor','red',...
              'ForegroundColor','white',...
              'position',[10 200  300 20], 'visible','off'); drawnow;
firstp=1;
updaten;
% Leaves the control window on top
         figure(F2); 



